#!/bin/sh
###
# Copyright (C) 2016 Serg A. Kotlyarov <shadowsbrother@gmail.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the
# Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
# MA 02110-1301, USA.

i=`ls -fd -1 /tmp/* 2>/dev/null|grep "^/tmp.*.tmp.hcl-get$"`
[[ ! $i || -d $i || `echo "$i"|wc -l` != 1 ]] && exit 0
b=`basename $i`
t=${b%.*}
d="`cat $i`/tmp/${t%.*}"
rm -f $i
a=hcl-get.tar
r=$d/$a
f=frequency
h=hwinfo
l="echo -n ."
s=system-report
e() {
echo error > $d/$1.err
exit 0
}
sr() {
$s $o 2&>/var/log/$s.log
}
ts() {
for ((z=0;z<60;z++))
do
 [[ `jobs|grep '+  Done'` ]] && break
 $l
 sleep 1
done
}
echo -n $'\n'"Сбор информации о системе"
v=`rpm -q --queryformat=%{VERSION} $s`
w=${v%.*}
if [[ ${w##*.} = 0 && ${v##*.} < 9 ]]; then
 o="-o $r.bz2"
 p="$r.bz2"
else
 o="-o $r"
fi
sr &
ts
# Костыль для обхода проблем с завершением работы вызываемых посредством
# system-report утилит
if [[ `jobs|grep '+  Running'` ]]; then
 killall $s
 printf '\nВыполнение system-report занимает слишком много времени.
Будет предпринята попытка повторного запуска с пропуском проблемного компонента\n'
 ls=`tail -n1 /var/log/$s.log|sed 's,[ \t]*$,,'`
 ns=`cat $s|grep -A3 "$ls"|grep '|| return 0$'`
 p1=${ns%%]*}; ao=`echo ${p1##*$}|tr -d '"'`
 [[ $ao ]] || e $s
 rm -f $d/* 2&>/dev/null
 o="-$ao $o"
 sr &
 ts
fi
#
if [[ ! $p ]]; then
 for x in xz bz2 gz; do
  [[ -s $r.$x ]] && p=$r.$x
 done
fi
[[ $p || -s $p ]] || e $s
if [[ ! `cat /proc/cpuinfo|grep '^model name.*[0-9][.0-9]*[GM]Hz$'` ]]; then
 dmidecode -s processor-$f > $d/$f
 [ -s $d/$f ] || e $f
 $l
fi
$h > $d/$h &
ts
[ -s $d/$h ] || e $h
echo
exit 0
